package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLPWMultiAffList_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLPWMultiAffList extends JNIObject  {
	
	/* @generated */
	protected ISLPWMultiAffList(long ptr) {
		/*** PROTECTED REGION ID(ISLPWMultiAffList_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLPWMultiAffList build(long ptr) {
		return new ISLPWMultiAffList(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLPWMultiAffList_userCode) ENABLED START ***/
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_pw_multi_aff_list_alloc 
	 * 
	 * @generated
	**/
	 public static ISLPWMultiAffList build(ISLContext ctx, int n) { 
		/*** PROTECTED REGION ID(static_isl_pw_multi_aff_list_alloc) DISABLED START ***/
		ISLPWMultiAffList res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLPWMultiAffList.build(ISLNative.isl_pw_multi_aff_list_alloc(getNativePtr(ctx), n));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_list_to_string 
	 * 
	 * @generated
	**/
	 public static String _toString(ISLPWMultiAffList palist, int format) { 
		/*** PROTECTED REGION ID(static_isl_pw_multi_aff_list_to_string) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_pw_multi_aff_list_to_string(getNativePtr(palist), format);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_pw_multi_aff_list_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_list_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_pw_multi_aff_list_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_list_copy 
	 * 
	 * @generated
	**/
	public ISLPWMultiAffList copy() {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_list_copy) DISABLED START ***/
		ISLPWMultiAffList res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLPWMultiAffList.build(ISLNative.isl_pw_multi_aff_list_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_list_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_list_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_pw_multi_aff_list_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_list_n_pw_multi_aff 
	 * 
	 * @generated
	**/
	public int getNbPWMultiAffs() {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_list_n_pw_multi_aff) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_pw_multi_aff_list_n_pw_multi_aff(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_list_get_pw_multi_aff 
	 * 
	 * @generated
	**/
	public ISLPWMultiAff get(int index) {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_list_get_pw_multi_aff) DISABLED START ***/
		ISLPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLPWMultiAff.build(ISLNative.isl_pw_multi_aff_list_get_pw_multi_aff(getNativePtr(this), index));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_list_set_pw_multi_aff 
	 * 
	 * @take this pa
	 * @generated
	**/
	public ISLPWMultiAffList set(int index, ISLPWMultiAff pa) {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_list_set_pw_multi_aff) DISABLED START ***/
		ISLPWMultiAffList res;
		
		synchronized(LOCK) {
			checkParameters(this, pa);
			try {
				res = ISLPWMultiAffList.build(ISLNative.isl_pw_multi_aff_list_set_pw_multi_aff(getNativePtr(this), index, getNativePtr(pa)));
			} finally {
				taken(this);
				taken(pa);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_list_insert 
	 * 
	 * @take this el
	 * @generated
	**/
	public ISLPWMultiAffList insert(int pos, ISLPWMultiAff el) {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_list_insert) DISABLED START ***/
		ISLPWMultiAffList res;
		
		synchronized(LOCK) {
			checkParameters(this, el);
			try {
				res = ISLPWMultiAffList.build(ISLNative.isl_pw_multi_aff_list_insert(getNativePtr(this), pos, getNativePtr(el)));
			} finally {
				taken(this);
				taken(el);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_list_add 
	 * 
	 * @take this el
	 * @generated
	**/
	public ISLPWMultiAffList add(ISLPWMultiAff el) {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_list_add) DISABLED START ***/
		ISLPWMultiAffList res;
		
		synchronized(LOCK) {
			checkParameters(this, el);
			try {
				res = ISLPWMultiAffList.build(ISLNative.isl_pw_multi_aff_list_add(getNativePtr(this), getNativePtr(el)));
			} finally {
				taken(this);
				taken(el);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_list_drop 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLPWMultiAffList drop(int first, int n) {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_list_drop) DISABLED START ***/
		ISLPWMultiAffList res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLPWMultiAffList.build(ISLNative.isl_pw_multi_aff_list_drop(getNativePtr(this), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_list_concat 
	 * 
	 * @take this list2
	 * @generated
	**/
	public ISLPWMultiAffList concat(ISLPWMultiAffList list2) {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_list_concat) DISABLED START ***/
		ISLPWMultiAffList res;
		
		synchronized(LOCK) {
			checkParameters(this, list2);
			try {
				res = ISLPWMultiAffList.build(ISLNative.isl_pw_multi_aff_list_concat(getNativePtr(this), getNativePtr(list2)));
			} finally {
				taken(this);
				taken(list2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLPWMultiAffList_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
